VIDEO_MODE = (640, 480)
ASPECT_RATIO = float(VIDEO_MODE[0]) / VIDEO_MODE[1]
SCREEN_LEFT = -0.5 * ASPECT_RATIO
SCREEN_RIGHT = -SCREEN_LEFT

FPS = 20.0

WINDOW_TITLE = "Garbage Collector v1.0a // by Mindless Labs."

ANG_STEP = 45.0

IMAGE_PATH = "data/images"
SOUND_PATH = "data/sounds"
MUSIC_PATH = "data/music"
FONT_PATH  = "data/fonts"
SOURCE_PATH = "data/sources"

MENU_FONT = "transrobotics.ttf"
TITLE_FONT = "256bytes.ttf"
SOURCE_FONT = "whitrabt.ttf"

SOURCE_C = "csg.c"
SOURCE_CPP = "binheap.cpp"
SOURCE_PYTHON = "texture.py"
SOURCE_ASSEMBLY = "poly.asm"

SOURCE_ALL = [SOURCE_PYTHON, SOURCE_C, SOURCE_CPP, SOURCE_ASSEMBLY]

######

# max_mem, start_mem, (self.ringMin, self.ringMax), (self.genMin, self.genMax), self.badChainPoss, self.chainSpeedMul = params
PARAMS = [
   # python
   (
      4096, # max mem
      2048, # start mem
      (6.0, 15.0), # ring secs
      (2.0, 7.0), # chain gen secs
      0.2, # possibility of a bad chain
      1.0, # WanderChain speed multiplier
      0.75, # weighting of number of chain elems -> bigger -> slower movement (can be > 1.0)
   ),   
   #c
   (
      8192, # max mem
      8192 - 2048, # start mem
      (9.0, 18.0), # ring secs
      (1.0, 4.0), # chain gen secs
      0.3, # possibility of a bad chain
      1.1, # WanderChain speed multiplier
      0.8,
   ),   
   # cpp
   (
      8192, # max mem
      8192 - 2048, # start mem
      (10.0, 20.0), # ring secs
      (1.0, 3.0), # chain gen secs
      0.3, # possibility of a bad chain
      1.2, # WanderChain speed multiplier
      0.9,
   ),   
   # assembly
   (
      8192, # max mem
      8192 - 2048, # start mem
      (10.0, 20.0), # ring secs
      (1.0, 2.5), # chain gen secs
      0.4, # possibility of a bad chain
      1.35, # WanderChain speed multiplier
      1.0,
   ),
]

######

def setVideoMode(mode):
   global VIDEO_MODE, ASPECT_RATIO, SCREEN_LEFT, SCREEN_RIGHT
   
   VIDEO_MODE = mode
   ASPECT_RATIO = float(VIDEO_MODE[0]) / VIDEO_MODE[1]
   SCREEN_LEFT = -0.5 * ASPECT_RATIO
   SCREEN_RIGHT = -SCREEN_LEFT

